/*

 Thmath
 It'th a thmath to uthe thring math!
 (c) 2005 Jonathan Bettencourt / Kreative Korporation

 Thith here thee++ code ith a port of ThtringMathLib in RealBathic
 and MathLib in HyperCard. It will do thimple thtring math on thtrings
 of arbitrary length, with no limit to prethithion.


 Addition, subtraction, multiplication, and positive integer powers
 are *unlimited* in precision, regardless of the setting of th_precision.

 Division, modulus, square root, and powers that are multiples of 1/2
 are limited to the precision set by th_precision.

 Trigonometric functions, hyperbolic functions, logarithmic functions,
 gamma functions, and real number powers are limited to a precision of
 either th_precision or a little more than 500, whichever is less.

 To increase (or decrease) the precision of trig, hyp, log, gamma functions:
	* Add more digits to the constants in th_constants.cpp
	* Increase the value of th_const_prec in thmath.cpp
	* Add more factorials to th_factorialtable.cpp
	* Increase the value of th_max_factorial in thmath.cpp


 This code is under the MIT license.

 Permission is hereby granted, free of charge, to any person obtaining a copy of
 this software and associated documentation files (the "Software"), to deal in the
 Software without restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
 Software, and to permit persons to whom the Software is furnished to do so,
 subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies
 or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/

#ifndef _____THMATH_____
#define _____THMATH_____

#include <string>
using namespace std;

bool th_zero(string);
bool th_equal(string,string);
string th_compare(string,string);

string th_trim(string);
string th_trunc(string);
string th_sign(string);

int th_gprecision(void);
void th_sprecision(int);

string th_add(string,string);
string th_subtract(string,string);
string th_multiply(string,string);
string th_divide(string,string,bool);
string th_divide(string,string);
string th_div(string,string);
string th_mod(string,string);
string th_pow(string,string);	/* implemented but TERRIBLY slow for noninteger / non-multiple-of-1/2 powers */

string th_lastmod(string,string);
string th_fastdivide(string,string);

string th_abs(string);
string th_square(string);
string th_sqrt(string);

string th_ln(string);		/* implemented but TERRIBLY slow */
string th_exp(string);		/* implemented but slow */

string th_sin(string);		/* implemented but slow */
string th_cos(string);		/* implemented but slow */
string th_tan(string);		/* implemented but REALLY slow */
string th_cot(string);		/* implemented but REALLY slow */
string th_sec(string);		/* implemented but slow */
string th_csc(string);		/* implemented but slow */

string th_asin(string);		/* implemented but TERRIBLY slow */
string th_acos(string);		/* implemented but TERRIBLY slow */
string th_atan(string);		/* implemented but TERRIBLY slow */
string th_acot(string);		/* implemented but TERRIBLY slow */
string th_asec(string);		/* implemented but TERRIBLY slow */
string th_acsc(string);		/* implemented but TERRIBLY slow */

string th_sinh(string);		/* implemented but slow */
string th_cosh(string);		/* implemented but slow */
string th_tanh(string);		/* implemented but REALLY slow */
string th_coth(string);		/* implemented but REALLY slow */
string th_sech(string);		/* implemented but slow */
string th_csch(string);		/* implemented but slow */

string th_asinh(string);	/* implemented but TERRIBLY slow */
string th_acosh(string);	/* implemented but TERRIBLY slow */
string th_atanh(string);	/* implemented but TERRIBLY slow */
string th_acoth(string);	/* implemented but TERRIBLY slow */
string th_asech(string);	/* implemented but TERRIBLY slow */
string th_acsch(string);	/* implemented but TERRIBLY slow */

string th_maclaurin(string, int, int, bool, bool, bool, int, int);
string th_factorial(string);	/* implemented but HORRENDOUSLY slow for nonintegers / non-multiples-of-1/2 */
string th_gamma(string);	/* implemented but HORRENDOUSLY slow for nonintegers / non-multiples-of-1/2 */
string th_constant(string);	/* NOT IMPLEMENTED */

bool th_czero(string);
bool th_cequal(string,string);
string th_ccompare(string,string);
string th_ctrunc(string);
string th_csign(string);
string th_ctrim(string);
string th_cadd(string,string);
string th_csubtract(string,string);
string th_cmultiply(string,string);
string th_cdivide(string,string,bool);
string th_cdivide(string,string);
string th_cdiv(string,string);
string th_cmod(string,string);
string th_cpow(string,string);	/* implemented but TERRIBLY slow */
string th_cabs(string);
string th_csquare(string);
string th_csqrt(string);


/*  FUNCTIONS INTERNAL TO THMATH  */

string th__str(int x);
void th__test(int, int, int);

inline int th__abs(int x)
{
	return (x<0)?0-x:x;
}

inline int th__diff(int x, int y)
{
	return (x>y)?x-y:y-x;
}

inline int th__min(int x, int y)
{
	return (x>y)?y:x;
}

inline int th__max(int x, int y)
{
	return (x>y)?x:y;
}

#endif

